﻿if (jQuery) (function ($) {
  $.fn.extend(
    {
      tree: function (args) {
        var defaults = { "type": "list", "name": "file", "src": "/", "attr": "dir", "speed": 50, "refresh": false };
        var self = this;
        var opts = null;
        if (self.attr('absrc')) {
          opts = $.extend(defaults, { "src": self.attr('absrc') });
        }
        opts = $.extend(defaults, args);

        self.MsgHandle = function (msg) {
          if (msg == null) return;
          if (msg.name == undefined) return;
          switch (msg.name) {
            case "file":
              switch (msg.type) {
                case "list":
                  if (msg.status == "success")
                    self.bindTree(msg);
                  break;
                default: break;
              }
              break;
            default:
              break;
          }
        };

        self.bindTree = function (msg) {
          var $loading = self.children("img:first");
          $loading.removeClass();
          self.attr("expandSta", "expand");
          if (msg.data == null) return;
          var path = msg.data.path,
              files = msg.data.files;
          if (files == null || files.length < 1) {
            if (opts.refresh) {
              $loading.addClass('expand_empty').unbind();
              self.children("img:eq(1)").removeClass().addClass('dir_empty');
              self.unbind("dblclick");
            }
            return;
          }
          var fileLen = files.length;
          if (opts.refresh && !self.data('events')['dbclick']) {
            imgHandler($loading);
            self.children("img:eq(1)").removeClass().addClass('dir');
            divHandler(self, false);
          }

          $loading.addClass("expand_off");
          var treeDepth = parseInt(self.attr("depth")) + 1;
          var $ul = self.next('ul');
          if ($ul.length < 1) {
            $ul = $('<ul>');
            $ul.insertAfter(self);
          }
          if (msg.data.path == "/") {
            imgHandler($loading);
            if (msg.data.rootname) {
              $.extend({ 'rootName': msg.data.rootname });
              self.find('span').text($.rootName);
            }
            divHandler(self, false);
          }
          for (var i = 0; i < fileLen; i++) {
            var file = files[i];
            var src = msg.data.path;
            if (src == "/") {
              src += file.name;
            } else {
              src = src + "/" + file.name;
            }
            if (opts.refresh && $('#file_tree div[absrc="' + src + '"]').length > 0) {
              continue;
            }
            var $div = $("<div class='leaf item_normal'>");
            var imgClass = "collapse_off";
            if (file.empty) {
              imgClass = "expand_empty";
            }
            var $img = $("<img src='img/ui/images/bg_blank.gif' alt=''/>");
            $img.addClass(imgClass)
                .css("margin-left", treeDepth * 10 + "px")
                .appendTo($div);
            if (!file.empty) {
              imgHandler($img);
            }
            var status = "";
            if (file.empty) status = "empty";
            $("<img src='img/ui/images/bg_blank.gif' alt=''/>").addClass(getClassByType(file.type, status)).appendTo($div);
            $div.append("<span>" + file.name + "</span>")
              .attr("absrc", src)
              .attr("depth", treeDepth);
            divHandler($div, file.empty);
            $("<li>").append($div).appendTo($ul);
          }
          $ul.hide().slideDown(opts.speed);
          $("#file_tree div").droppable({
                drop: function (event, ui) {
                	$(this).css("background-color", "#FFFFFF");
                	$.moveDirOrFile($.getSelectedDirFile(),$(this).attr("absrc"));
                },
                over: function (event, ui) {
                    $(this).css("background-color", "rgb(196,221,252)");
                },
                out: function (event, ui) {
                    $(this).css("background-color", "#FFFFFF");
                }
            }); 
        };

        function imgHandler($ele) {
          $ele
          .unbind('mouseover')
          .bind('mouseover', function () {
            var $e = $(this);
            var status = $e.parent("div").attr("expandSta") || "collapse";
            $e.removeClass().addClass(status + "_on");
          })
          .unbind('mouseout')
          .bind('mouseout', function () {
            var $e = $(this);
            var status = $e.parent("div").attr("expandSta") || "collapse";
            $e.removeClass().addClass(status + "_off");
          })
          .unbind("click")
          .bind("click", function (event) {
            $(this).parent("div").dblclick();
            event.stopPropagation();
          });
        };

        function divHandler($ele, isEmpty) {
          if ($ele.attr("absrc") != "/") {
          }
          $ele.hover(function () {
            var $e = $(this);
            if ($e.hasClass("ui-selected")) { return; }
            $e.addClass("item_hover").removeClass("item_normal");
          }, function () {
            var $e = $(this).children("div").eq(0);
            if ($e.hasClass("ui-selected")) { return; }
            $("#file_tree").find(".item_hover").removeClass("item_hover").addClass("item_normal");
          })
          .unbind('click')
          .bind("click", function (event) {
            var $e = $(this);
            $("#file_tree").find(".ui-selected").removeClass("ui-selected").addClass("item_normal");
            $e.addClass("ui-selected")
              .removeClass("item_normal")
              .removeClass("item_hover");
			$.getDirect($e.attr("absrc"));
            event.stopPropagation();
          });
          if (!isEmpty) {
            $ele
            .unbind('dblclick')
            .bind("dblclick", function (event) {
              var $e = $(this);
              $e.tree({ "src": $e.attr("absrc") });
			  $.getDirect($e.attr("absrc"));
              event.stopPropagation();
            });
          }
        };

        function getClassByType(type, status) {
          switch (type) {
            case "dir":
              switch (status) {
                case "empty":
                  return "dir_empty";
                default:
                  return "dir";
              }
              break;
          }
        };

        function listTree(msg) {
          $.severHandler(msg,
            function () {
              if (msg['refresh']) { return; }
              self.children("img:first").removeClass().addClass("tree-loading");
            },
            self.MsgHandle);
        };

        return self.each(function () {
          var child = self.next("ul:first");
          if (child.length > 0 && !opts.refresh) {
            if (child.css("display") == "none") {
              child.slideDown(opts.speed);
              self.find("img:first").removeClass().addClass("expand_off");
              self.attr("expandSta", "expand");
            }
            else {
              child.slideUp(opts.speed);
              self.find("img:first").removeClass().addClass("collapse_off");
              self.attr("expandSta", "collapse");
            }
            return;
          }
          listTree(opts);
        });
      }
    });
})(jQuery);